# A unit test for hts() function
context("Tests on inputs")

test_that("tests for y as a mts", {
  set.seed(1234)
  sts <- ts(rnorm(100), start = c(2001, 1), frequency = 12)
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))

  expect_that(hts(sts, node.list), throws_error())
})

test_that("tests for node as a list", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.mat <- matrix(1:10, nrow = 2, ncol = 5)

  expect_that(hts(mts, node.mat), throws_error())
})

test_that("tests for node by default", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  nodes <- list("Level 1" = 10)

  expect_that(hts(mts)$nodes, equals(nodes))
})

test_that("tests for the root node not specified", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(c(2, 3, 1), c(2, 2, 1, 1, 1, 3))

  expect_that(hts(mts, node.list), throws_error())
})

test_that("tests for the terminal nodes wrong", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(1, c(2, 3, 1), c(2, 2, 1, 2, 1, 3))

  expect_that(hts(mts, node.list), throws_error())
})

test_that("tests for the middle nodes wrong", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(1, c(2, 4, 1), c(2, 2, 1, 1, 1, 3))

  expect_that(hts(mts, node.list), throws_error())
})

context("tests on output")

test_that("tests for the gmatrix", {
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))
  g <- matrix(c(rep(1, 10), rep(1, 4), rep(2, 3), rep(3, 3), rep(1, 2), 
                rep(2, 2), seq(3, 5), rep(6, 3), seq(1, 10)), ncol = 10, 
                byrow = TRUE)
  class(g) <- "gmatrix"

  output <- GmatrixH(node.list)
  dimnames(output) <- NULL
  expect_that(output, equals(g))
})

# A unit test for the inverse of row sums of smatrix
test_that("tests for hts", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))
  hts <- hts(mts, nodes = node.list)
  s <- 1/rowSums(smatrix(hts))

  expect_that(InvS4h(node.list), equals(s))
})

test_that("tests for gts", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(2700)), nrow = 100, ncol = 27), 
            start = c(2001, 1), frequency = 12)
  g <- matrix(c(rep(1:3, each = 9), rep(c(rep(1, 3), rep(2, 3), rep(3, 3)), 3),
              rep(1:3, 9)), nrow = 3, byrow = TRUE)
  gts <- gts(mts, groups = g)
  s <- 1/rowSums(smatrix(gts))
  out <- InvS4g(gts$groups)
  names(out) <- NULL

  expect_that(out, equals(s))
})

# A unit test for aggts() function
context("Tests on input")
test_that("tests for a non-gts object", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  
  expect_that(aggts(mts), throws_error())
})

context("Tests on output")
test_that("tests for a non-gts object", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))
  hts <- hts(mts, nodes = node.list)
  out <- dim(aggts(hts))
  
  expect_that(out, equals(c(50, 20)))
})

# A unit test for forecast.gts() function
test_that("tests for 3 dots", {
  f1 <- forecast(htseg2, h = 4, algorithms = "lu")
  f2 <- forecast(htseg2, h = 4, ic = "aic", algorithms = "lu")
  
  expect_false(all(f1$bts == f2$bts))
})

# A unit test for gts() function
context("Tests on output")

test_that("tests for labels", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(2700)), nrow = 100, ncol = 27), 
            start = c(2001, 1), frequency = 12)
  g <- matrix(c(rep(1:3, each = 9), rep(c(rep(1, 3), rep(2, 3), rep(3, 3)), 3),
              rep(1:3, 9)), nrow = 3, byrow = TRUE)
  output <- paste0("G", 1:3)
  expect_that(names(gts(mts, g)$labels), equals(output))
})

test_that("tests for specified labels", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(2700)), nrow = 100, ncol = 27), 
            start = c(2001, 1), frequency = 12)
  g <- matrix(c(rep(1:3, each = 9), rep(c(rep(1, 3), rep(2, 3), rep(3, 3)), 3),
              rep(1:3, 9)), nrow = 3, byrow = TRUE)
  rownames(g) <- c("Sex", "Purpose", "Frames")
  expect_that(names(gts(mts, g)$labels), equals(rownames(g)))
})

test_that("tests for gmatrix", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(2700)), nrow = 100, ncol = 27), 
            start = c(2001, 1), frequency = 12)
  g <- matrix(c(rep(1:3, each = 9), rep(c(rep(1, 3), rep(2, 3), rep(3, 3)), 3),
              rep(1:3, 9)), nrow = 3, byrow = TRUE)
  gmat <- rbind(rep(1, 27), g, seq(1, 27))
  class(gmat) <- "gmatrix"
  output <- gts(mts, g)$groups
  dimnames(output) <- NULL

  expect_that(output, equals(gmat))
})

test_that("tests for matrix with characters", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(1600)), nrow = 100, ncol = 16), 
            start = c(2001, 1), frequency = 12)
  gchar <- matrix(c(rep("Male", 8), rep("Female", 8), rep(LETTERS[3:10], 2)),
                  nrow = 2, byrow = TRUE)
  g <- matrix(c(rep(1, 8), rep(2, 8), rep(1:8, 2)), nrow = 2, byrow = T)
  gmat <- rbind(rep(1, 16), g, seq(1, 16))
  class(gmat) <- "gmatrix"
  output <- gts(mts, gchar)$groups
  dimnames(output) <- NULL

  expect_that(output, equals(gmat))
})

# A unit test for combinef() function
context("Tests on inputs")

test_that("tests for hts at the bottom level", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(500)), nrow = 50, ncol = 10))
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))

  expect_that(combinef(mts, nodes = node.list, algorithms = "lu"), 
              throws_error())
})

context("Tests on outputs")

test_that("tests for hts", {
  set.seed(1234)
  mts <- ts(matrix(5 + sort(rnorm(50)), nrow = 5, ncol = 10))
  node.list <- list(3, c(2, 3, 1), c(2, 2, 1, 1, 1, 3))
  hts <- hts(mts, nodes = node.list)
  allf <- allts(hts)
  out1 <- combinef(allf, nodes = node.list, keep = "bottom", algorithms = "lu")
  out2 <- combinef(allf, nodes = node.list, keep = "gts", algorithms = "lu")

  expect_that(dim(out1), equals(c(5, 10)))
  expect_true(is.hts(out2))
})

test_that("tests for gts", {
  set.seed(1234)
  mts <- ts(5 + matrix(sort(rnorm(270)), nrow = 10, ncol = 27), 
            start = c(2001, 1), frequency = 12)
  g <- matrix(c(rep(1:3, each = 9), rep(c(rep(1, 3), rep(2, 3), rep(3, 3)), 3),
              rep(1:3, 9)), nrow = 3, byrow = TRUE)
  gts <- gts(mts, groups = g)
  out1 <- combinef(allts(gts), groups = gts$groups, keep = "bottom",
                   algorithms = "lu")
  out2 <- combinef(allts(gts), groups = g, keep = "gts", algorithms = "lu")

  expect_that(dim(out1), equals(c(10, 27)))
  expect_that(dim(out2$bts), equals(c(10, 27)))
})
